PF-build.sh 33 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_9
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. #### Start check if OSTYPE is supported
  116. OS_FOUND=$( command -v uname)
  117. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  118. linux*)
  119. TARGET_OS="linux"
  120. ;;
  121. msys*|cygwin*|mingw*)
  122. # or possible 'bash on windows'
  123. TARGET_OS='windows'
  124. ;;
  125. nt|win*)
  126. TARGET_OS='windows'
  127. ;;
  128. *)
  129. TARGET_OS='unknown'
  130. ;;
  131. esac
  132. # Windows
  133. if [ $TARGET_OS == "windows" ]; then
  134. if [ $(uname -m) == "x86_64" ]; then
  135. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  136. Processor="64"
  137. elif [ $(uname -m) == "i386" ]; then
  138. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  139. Processor="32"
  140. else
  141. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  142. echo "Please refer to the notes of build.sh$(tput sgr0)"
  143. exit 1
  144. fi
  145. # Linux
  146. elif [ $TARGET_OS == "linux" ]; then
  147. if [ $(uname -m) == "x86_64" ]; then
  148. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  149. Processor="64"
  150. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  151. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  152. Processor="32"
  153. else
  154. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  155. echo "Please refer to the notes of build.sh$(tput sgr0)"
  156. exit 1
  157. fi
  158. else
  159. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  160. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  161. echo "Read the notes of build.sh$(tput sgr0)"
  162. exit 1
  163. fi
  164. sleep 2
  165. #### End check if OSTYPE is supported
  166. #### Prepare bash environment and check if wget, zip and other needed things are available
  167. # Check wget
  168. if ! type wget > /dev/null; then
  169. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  170. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  171. exit 2
  172. fi
  173. # Check for zip
  174. if ! type zip > /dev/null; then
  175. if [ $TARGET_OS == "windows" ]; then
  176. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  177. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  178. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  179. echo "Run git Bash under Administrator privilege and"
  180. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  181. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  182. exit 3
  183. elif [ $TARGET_OS == "linux" ]; then
  184. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  185. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  186. exit 3
  187. fi
  188. fi
  189. # Check python ... needed during language build
  190. if ! type python > /dev/null; then
  191. if [ $TARGET_OS == "windows" ]; then
  192. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  193. exit 4
  194. elif [ $TARGET_OS == "linux" ]; then
  195. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  196. echo "As Python 2.x will not be maintained from 2020 please,"
  197. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  198. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  199. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  200. exit 4
  201. fi
  202. fi
  203. #### End prepare bash environment
  204. #### Set build environment
  205. ARDUINO_ENV="1.8.5"
  206. BUILD_ENV="1.0.6"
  207. BOARD="PrusaResearchRambo"
  208. BOARD_VERSION="1.0.1"
  209. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  210. BOARD_FILENAME="prusa3drambo"
  211. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3drambo-1.0.1.tar.bz2"
  212. PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env/releases/download/$BUILD_ENV/PF-build-env-$BUILD_ENV.zip"
  213. LIB="PrusaLibrary"
  214. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  215. # List few useful data
  216. echo
  217. echo "Script path :" $SCRIPT_PATH
  218. echo "OS :" $OS
  219. echo "OS type :" $TARGET_OS
  220. echo ""
  221. echo "Ardunio IDE :" $ARDUINO_ENV
  222. echo "Build env :" $BUILD_ENV
  223. echo "Board :" $BOARD
  224. echo "Specific Lib:" $LIB
  225. echo ""
  226. #### Start prepare building environment
  227. #Check if build exists and creates it if not
  228. if [ ! -d "../PF-build-dl" ]; then
  229. mkdir ../PF-build-dl || exit 5
  230. fi
  231. cd ../PF-build-dl || exit 6
  232. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  233. # Check if PF-build-env-<version> exists and downloads + creates it if not
  234. # The build environment is based on the supported Arduino IDE portable version with some changes
  235. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  236. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  237. mkdir ../PF-build-env-$BUILD_ENV
  238. sleep 5
  239. fi
  240. # Download and extract supported Arduino IDE depending on OS
  241. # Windows
  242. if [ $TARGET_OS == "windows" ]; then
  243. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  244. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  245. sleep 2
  246. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  247. echo "$(tput sgr 0)"
  248. fi
  249. if [ ! -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor" ]; then
  250. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  251. sleep 2
  252. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  253. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor
  254. echo "# arduino-$ARDUINO_ENV-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$TARGET_OS-$Processor
  255. echo "$(tput sgr0)"
  256. fi
  257. fi
  258. # Linux
  259. if [ $TARGET_OS == "linux" ]; then
  260. # 32 or 64 bit version
  261. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  262. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  263. sleep 2
  264. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  265. echo "$(tput sgr 0)"
  266. fi
  267. if [[ ! -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$TARGET_OS-$Processor.txt" ]]; then
  268. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  269. sleep 2
  270. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  271. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor
  272. echo "# arduino-$ARDUINO_ENV-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$TARGET_OS-$Processor.txt
  273. echo "$(tput sgr0)"
  274. fi
  275. fi
  276. # Make Arduino IDE portable
  277. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/ ]; then
  278. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/
  279. fi
  280. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/ ]; then
  281. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable
  282. fi
  283. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/output/ ]; then
  284. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/output
  285. fi
  286. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/ ]; then
  287. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages
  288. fi
  289. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  290. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/sketchbook
  291. fi
  292. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  293. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/sketchbook/libraries
  294. fi
  295. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/staging/ ]; then
  296. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/staging
  297. fi
  298. # Change Arduino IDE preferences
  299. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$TARGET_OS-$Processor.txt ]; then
  300. echo "$(tput setaf 6)Setting $TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  301. sleep 2
  302. echo "update.check"
  303. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  304. echo "board"
  305. sed -i 's/board = uno/board = rambo/g' ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  306. echo "editor.linenumbers"
  307. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  308. echo "boardsmanager.additional.urls"
  309. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  310. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  311. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  312. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  313. echo "# Preferences-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$TARGET_OS-$Processor.txt
  314. echo "$(tput sgr0)"
  315. fi
  316. # Download and extract Prusa Firmware related parts
  317. # Download and extract PrusaResearchRambo board
  318. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  319. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  320. sleep 2
  321. wget $BOARD_FILE_URL || exit 9
  322. fi
  323. if [[ ! -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  324. echo "$(tput setaf 6)Unzipping $BOARD Arduino IDE portable...$(tput setaf 2)"
  325. sleep 2
  326. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  327. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD ]; then
  328. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD
  329. fi
  330. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD ]; then
  331. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD
  332. fi
  333. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD/hardware ]; then
  334. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD/hardware
  335. fi
  336. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD/hardware/avr ]; then
  337. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD/hardware/avr
  338. fi
  339. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD/hardware/avr/$BOARD_VERSION
  340. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  341. echo "$(tput sgr 0)"
  342. fi
  343. # Download and extract Prusa Firmware specific library files
  344. if [ ! -f "PF-build-env-$BUILD_ENV.zip" ]; then
  345. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  346. sleep 2
  347. wget $PF_BUILD_FILE_URL || exit 11
  348. echo "$(tput sgr 0)"
  349. fi
  350. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$TARGET_OS-$Processor.txt" ]; then
  351. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  352. sleep 2
  353. unzip -o PF-build-env-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor || exit 12
  354. echo "# PF-build-env-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$TARGET_OS-$Processor.txt
  355. echo "$(tput sgr0)"
  356. fi
  357. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  358. if [ -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  359. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  360. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  361. sleep 2
  362. fi
  363. if [ -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  364. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  365. sleep 2
  366. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  367. sleep 2
  368. cp -f ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  369. echo "# PF-build-env-portable-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$TARGET_OS-$Processor.txt
  370. echo "$(tput sgr0)"
  371. fi
  372. if [ -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  373. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  374. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  375. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  376. sleep 2
  377. echo "$(tput sgr0)"
  378. exit 13
  379. fi
  380. #### End prepare building
  381. #### Start
  382. cd $SCRIPT_PATH
  383. # First argument defines which variant of the Prusa Firmware will be compiled
  384. if [ -z "$1" ] ; then
  385. # Select which variant of the Prusa Firmware will be compiled, like
  386. PS3="Select a variant: "
  387. while IFS= read -r -d $'\0' f; do
  388. options[i++]="$f"
  389. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  390. select opt in "${options[@]}" "All" "Quit"; do
  391. case $opt in
  392. *.h)
  393. VARIANT=$(basename "$opt" ".h")
  394. VARIANTS[i++]="$opt"
  395. break
  396. ;;
  397. "All")
  398. VARIANT="All"
  399. VARIANTS=${options[*]}
  400. break
  401. ;;
  402. "Quit")
  403. echo "You chose to stop"
  404. exit
  405. ;;
  406. *)
  407. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  408. ;;
  409. esac
  410. done
  411. else
  412. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  413. VARIANTS=$1
  414. else
  415. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  416. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  417. echo "$(tput sgr0)"
  418. exit 21
  419. fi
  420. fi
  421. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  422. #Check default language mode
  423. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  424. if [ -z "$2" ] ; then
  425. PS3="Select a language: "
  426. echo
  427. echo "Which lang-build do you want?"
  428. select yn in "Multi languages" "English only"; do
  429. case $yn in
  430. "Multi languages")
  431. LANGUAGES="ALL"
  432. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  433. break
  434. ;;
  435. "English only")
  436. LANGUAGES="EN_ONLY"
  437. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  438. break
  439. ;;
  440. *)
  441. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  442. ;;
  443. esac
  444. done
  445. else
  446. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  447. LANGUAGES=$2
  448. else
  449. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  450. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  451. exit 22
  452. fi
  453. fi
  454. #Check if DEV_STATUS is selected via argument 3
  455. if [ ! -z "$3" ] ; then
  456. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" ]] ; then
  457. DEV_STATUS_SELECTED=$3
  458. else
  459. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  460. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL' or 'DEBUG'$(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  461. exit 23
  462. fi
  463. fi
  464. #Set BUILD_ENV_PATH
  465. cd ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor || exit 24
  466. BUILD_ENV_PATH="$( pwd -P )"
  467. cd ../..
  468. #Checkif BUILD_PATH exists and if not creates it
  469. if [ ! -d "Prusa-Firmware-build" ]; then
  470. mkdir Prusa-Firmware-build || exit 25
  471. fi
  472. #Set the BUILD_PATH for Arduino IDE
  473. cd Prusa-Firmware-build || exit 26
  474. BUILD_PATH="$( pwd -P )"
  475. for v in ${VARIANTS[*]}
  476. do
  477. VARIANT=$(basename "$v" ".h")
  478. # Find firmware version in Configuration.h file and use it to generate the hex filename
  479. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  480. # Find build version in Configuration.h file and use it to generate the hex filename
  481. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  482. # Check if the motherboard is an EINSY and if so only one hex file will generated
  483. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  484. # Check development status
  485. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  486. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  487. if [[ "$DEV_CHECK" == "RC1" || "$DEV_CHECK" == "RC2" ]] ; then
  488. DEV_STATUS="RC"
  489. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  490. DEV_STATUS="ALPHA"
  491. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  492. DEV_STATUS="BETA"
  493. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  494. DEV_STATUS="DEVEL"
  495. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  496. DEV_STATUS="DEBUG"
  497. else
  498. DEV_STATUS="UNKNOWN"
  499. echo
  500. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  501. PS3="Select YES only if source code is tested and trusted: "
  502. select yn in "Yes" "No"; do
  503. case $yn in
  504. Yes)
  505. DEV_STATUS="GOLD"
  506. DEV_STATUS_SELECTED="GOLD"
  507. break
  508. ;;
  509. No)
  510. DEV_STATUS="UNKNOWN"
  511. DEV_STATUS_SELECTED="UNKNOWN"
  512. break
  513. ;;
  514. *)
  515. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  516. ;;
  517. esac
  518. done
  519. fi
  520. else
  521. DEV_STATUS=$DEV_STATUS_SELECTED
  522. fi
  523. #Prepare hex files folders
  524. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  525. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  526. fi
  527. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  528. #Check if exactly the same hexfile already exists
  529. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  530. echo ""
  531. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  532. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  533. read -t 10 -p "Press Enter to continue..."
  534. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  535. echo ""
  536. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  537. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  538. read -t 10 -p "Press Enter to continue..."
  539. fi
  540. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  541. echo ""
  542. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  543. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  544. read -t 10 -p "Press Enter to continue..."
  545. fi
  546. #List some useful data
  547. echo "$(tput setaf 2)$(tput setab 7) "
  548. echo "Variant :" $VARIANT
  549. echo "Firmware :" $FW
  550. echo "Build # :" $BUILD
  551. echo "Dev Check :" $DEV_CHECK
  552. echo "DEV Status :" $DEV_STATUS
  553. echo "Motherboard:" $MOTHERBOARD
  554. echo "Languages :" $LANGUAGES
  555. echo "Hex-file Folder:" $OUTPUT_FOLDER
  556. echo "$(tput sgr0)"
  557. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  558. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  559. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  560. else
  561. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  562. read -t 10 -p "Press Enter to continue..."
  563. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  564. fi
  565. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  566. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  567. # set FW_REPOSITORY
  568. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  569. #Prepare english only or multilanguage version to be build
  570. if [ $LANGUAGES == "ALL" ]; then
  571. echo " "
  572. echo "Multi-language firmware will be built"
  573. echo " "
  574. else
  575. echo " "
  576. echo "English only language firmware will be built"
  577. echo " "
  578. fi
  579. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  580. # if [ $TARGET_OS == "windows" ]; then
  581. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  582. # fi
  583. #### End of Prepare building
  584. #### Start building
  585. export ARDUINO=$BUILD_ENV_PATH
  586. #echo $BUILD_ENV_PATH
  587. #export BUILDER=$ARDUINO/arduino-builder
  588. echo
  589. #read -t 5 -p "Press Enter..."
  590. echo
  591. echo "Start to build Prusa Firmware ..."
  592. echo "Using variant $VARIANT$(tput setaf 3)"
  593. sleep 2
  594. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD:avr:rambo -ide-version=10805 -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  595. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD:avr:rambo -ide-version=10805 -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  596. echo "$(tput sgr 0)"
  597. if [ $LANGUAGES == "ALL" ]; then
  598. echo "$(tput setaf 2)"
  599. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  600. echo "$(tput sgr 0)"
  601. sleep 2
  602. cd $SCRIPT_PATH/lang
  603. echo "$(tput setaf 3)"
  604. ./config.sh || exit 31
  605. echo "$(tput sgr 0)"
  606. # Check if previous languages and firmware build exist and if so clean them up
  607. if [ -f "lang_en.tmp" ]; then
  608. echo ""
  609. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  610. read -t 10 -p "Press Enter to continue..."
  611. echo "$(tput setaf 3)"
  612. ./lang-clean.sh
  613. echo "$(tput sgr 0)"
  614. fi
  615. if [ -f "progmem.out" ]; then
  616. echo ""
  617. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  618. read -t 10 -p "Press Enter to continue..."
  619. echo "$(tput setaf 3)"
  620. ./fw-clean.sh
  621. echo "$(tput sgr 0)"
  622. fi
  623. # build languages
  624. echo "$(tput setaf 3)"
  625. ./lang-build.sh || exit 32
  626. # Combine compiled firmware with languages
  627. ./fw-build.sh || exit 33
  628. echo "$(tput sgr 0)"
  629. # Check if the motherboard is an EINSY and if so only one hex file will generated
  630. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  631. # If the motherboard is an EINSY just copy one hexfile
  632. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  633. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  634. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  635. else
  636. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  637. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  638. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  639. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  640. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  641. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  642. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  643. if [ $TARGET_OS == "windows" ]; then
  644. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  645. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  646. elif [ $TARGET_OS == "linux" ]; then
  647. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  648. fi
  649. fi
  650. # Cleanup after build
  651. echo "$(tput setaf 3)"
  652. ./fw-clean.sh || exit 34
  653. ./lang-clean.sh || exit 35
  654. echo "$(tput sgr 0)"
  655. else
  656. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  657. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  658. fi
  659. # Cleanup Firmware
  660. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  661. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  662. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  663. echo $MULTI_LANGUAGE_CHECK
  664. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  665. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  666. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  667. sleep 5
  668. done
  669. # Switch to hex path and list build files
  670. cd $SCRIPT_PATH
  671. cd ..
  672. echo "$(tput setaf 2) "
  673. echo " "
  674. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  675. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  676. #### End building